

# GetCoreDevice
<a name="API_GetCoreDevice"></a>

Retrieves metadata for a Greengrass core device.

**Note**  
 Amazon IoT Greengrass relies on individual devices to send status updates to the Amazon Web Services Cloud. If the Amazon IoT Greengrass Core software isn't running on the device, or if device isn't connected to the Amazon Web Services Cloud, then the reported status of that device might not reflect its current status. The status timestamp indicates when the device status was last updated.  
Core devices send status updates at the following times:  
When the Amazon IoT Greengrass Core software starts
When the core device receives a deployment from the Amazon Web Services Cloud 
When the status of any component on the core device becomes `BROKEN` 
At a [regular interval that you can configure](https://docs.amazonaws.cn/greengrass/v2/developerguide/greengrass-nucleus-component.html#greengrass-nucleus-component-configuration-fss), which defaults to 24 hours
For Amazon IoT Greengrass Core v2.7.0, the core device sends status updates upon local deployment and cloud deployment
When the Amazon IoT Greengrass Core software connects to the Amazon Web Services Cloud, your device will be recognized as a core device.

## Request Syntax
<a name="API_GetCoreDevice_RequestSyntax"></a>

```
GET /greengrass/v2/coreDevices/coreDeviceThingName HTTP/1.1
```

## URI Request Parameters
<a name="API_GetCoreDevice_RequestParameters"></a>

The request uses the following URI parameters.

 ** [coreDeviceThingName](#API_GetCoreDevice_RequestSyntax) **   <a name="greengrassv2-GetCoreDevice-request-uri-coreDeviceThingName"></a>
The name of the core device. This is also the name of the Amazon IoT thing.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Required: Yes

## Request Body
<a name="API_GetCoreDevice_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_GetCoreDevice_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "architecture": "string",
   "coreDeviceThingName": "string",
   "coreVersion": "string",
   "lastStatusUpdateTimestamp": number,
   "platform": "string",
   "runtime": "string",
   "status": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## Response Elements
<a name="API_GetCoreDevice_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [architecture](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-architecture"></a>
The computer architecture of the core device.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.

 ** [coreDeviceThingName](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-coreDeviceThingName"></a>
The name of the core device. This is also the name of the Amazon IoT thing.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.

 ** [coreVersion](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-coreVersion"></a>
The version of the Amazon IoT Greengrass Core software that the core device runs. This version is equivalent to the version of the Greengrass nucleus component that runs on the core device. For more information, see the [Greengrass nucleus component](https://docs.amazonaws.cn/greengrass/v2/developerguide/greengrass-nucleus-component.html) in the * Amazon IoT Greengrass V2 Developer Guide*.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.

 ** [lastStatusUpdateTimestamp](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-lastStatusUpdateTimestamp"></a>
The time at which the core device's status last updated, expressed in ISO 8601 format.  
Type: Timestamp

 ** [platform](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-platform"></a>
The operating system platform that the core device runs.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.

 ** [runtime](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-runtime"></a>
The runtime for the core device. The runtime can be:  
+  `aws_nucleus_classic` 
+  `aws_nucleus_lite` 
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 255.

 ** [status](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-status"></a>
The status of the core device. The core device status can be:  
+  `HEALTHY` – The Amazon IoT Greengrass Core software and all components run on the core device without issue.
+  `UNHEALTHY` – The Amazon IoT Greengrass Core software or a component is in a failed state on the core device.
Type: String  
Valid Values: `HEALTHY | UNHEALTHY` 

 ** [tags](#API_GetCoreDevice_ResponseSyntax) **   <a name="greengrassv2-GetCoreDevice-response-tags"></a>
A list of key-value pairs that contain metadata for the resource. For more information, see [Tag your resources](https://docs.amazonaws.cn/greengrass/v2/developerguide/tag-resources.html) in the * Amazon IoT Greengrass V2 Developer Guide*.  
Type: String to string map  
Map Entries: Maximum number of 200 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Maximum length of 256.

## Errors
<a name="API_GetCoreDevice_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permission to perform the action.  
HTTP Status Code: 403

 ** InternalServerException **   
 Amazon IoT Greengrass can't process your request right now. Try again later.    
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The requested resource can't be found.    
 ** resourceId **   
The ID of the resource that isn't found.  
 ** resourceType **   
The type of the resource that isn't found.
HTTP Status Code: 404

 ** ThrottlingException **   
Your request exceeded a request rate quota. For example, you might have exceeded the amount of times that you can retrieve device or deployment status per second.    
 ** quotaCode **   
The code for the quota in [Service Quotas](https://docs.amazonaws.cn/servicequotas/latest/userguide/intro.html).  
 ** retryAfterSeconds **   
The amount of time to wait before you retry the request.  
 ** serviceCode **   
The code for the service in [Service Quotas](https://docs.amazonaws.cn/servicequotas/latest/userguide/intro.html).
HTTP Status Code: 429

 ** ValidationException **   
The request isn't valid. This can occur if your request contains malformed JSON or unsupported characters.    
 ** fields **   
The list of fields that failed to validate.  
 ** reason **   
The reason for the validation exception.
HTTP Status Code: 400

## See Also
<a name="API_GetCoreDevice_SeeAlso"></a>

For more information about using this API in one of the language-specific Amazon SDKs, see the following:
+  [Amazon Command Line Interface V2](https://docs.amazonaws.cn/goto/cli2/greengrassv2-2020-11-30/GetCoreDevice) 
+  [Amazon SDK for .NET V4](https://docs.amazonaws.cn/goto/DotNetSDKV4/greengrassv2-2020-11-30/GetCoreDevice) 
+  [Amazon SDK for C\$1\$1](https://docs.amazonaws.cn/goto/SdkForCpp/greengrassv2-2020-11-30/GetCoreDevice) 
+  [Amazon SDK for Go v2](https://docs.amazonaws.cn/goto/SdkForGoV2/greengrassv2-2020-11-30/GetCoreDevice) 
+  [Amazon SDK for Java V2](https://docs.amazonaws.cn/goto/SdkForJavaV2/greengrassv2-2020-11-30/GetCoreDevice) 
+  [Amazon SDK for JavaScript V3](https://docs.amazonaws.cn/goto/SdkForJavaScriptV3/greengrassv2-2020-11-30/GetCoreDevice) 
+  [Amazon SDK for Kotlin](https://docs.amazonaws.cn/goto/SdkForKotlin/greengrassv2-2020-11-30/GetCoreDevice) 
+  [Amazon SDK for PHP V3](https://docs.amazonaws.cn/goto/SdkForPHPV3/greengrassv2-2020-11-30/GetCoreDevice) 
+  [Amazon SDK for Python](https://docs.amazonaws.cn/goto/boto3/greengrassv2-2020-11-30/GetCoreDevice) 
+  [Amazon SDK for Ruby V3](https://docs.amazonaws.cn/goto/SdkForRubyV3/greengrassv2-2020-11-30/GetCoreDevice) 